package nz.gen.wellington.screenscrapers;

import java.math.BigDecimal;
import java.util.Date;

import nz.co.searchwellington.utils.UrlFilters;

public class NewsitemImpl implements Newsitem {

	private String title;
	private String url;
	private Date date;
	private String description;
	private String image;
	private String imageDescription;
	private BigDecimal latitude;
	private BigDecimal longitude;
	
	public NewsitemImpl() {
		title = "";
		description = "";
		url = "";
		date = null;
		image = null;
	}
	 
	public Date getDate() {
		return date;
	}

	public void setDate(Date date) {
		this.date = date;
	}
	   
	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public String getTitle() {
		return title;
	}

	public void setTitle(String title) {
		this.title = title;
	}

	public String getUrl() {
		return url;
	}

	public void setUrl(String url) {
		this.url = url;
	}

    public String getImage() {
		return image;
	}

	public void setImage(String image) {
		this.image = image;
	}

	public String getImageDescription() {
		return imageDescription;
	}

	public void setImageDescription(String imageDescription) {
		this.imageDescription = imageDescription;
	}
	
	public BigDecimal getLatitude() {
		return latitude;
	}

	public void setLatitude(BigDecimal latitude) {
		this.latitude = latitude;
	}

	public BigDecimal getLongitude() {
		return longitude;
	}

	public void setLongitude(BigDecimal longitude) {
		this.longitude = longitude;
	}

	// TODO shouldn't be on the model object
	public void flattenLoudCaps() {
        if (UrlFilters.isCapitalised(this.getTitle())) {
            this.setTitle(UrlFilters.lowerCappedSentence(this.getTitle()));
        }
    }

	@Override
	public String toString() {
		return "NewsitemImpl [date=" + date + ", description=" + description
				+ ", image=" + image + ", imageDescription=" + imageDescription
				+ ", latitude=" + latitude + ", longitude=" + longitude
				+ ", title=" + title + ", url=" + url + "]";
	}
	
}