package nz.gen.wellington.screenscrapers;

import java.util.List;
import java.util.Map;


/**
 * Screen Scrapers are used to extract Newsitems from HTML pages. 
 * We use these to obtain news feeds from sites which do not provide
 * their own feeds.
 * 
 * A screen scraper must tell it's calling application where to find 
 * the source HTML page, and provide a method to parse that HTML into
 * a List of Newsitems.
 * 
 * @author tony
 *
 */
public interface ScreenScraper {
	
	public String getName();
	public String getPageURL();
    public String getCharacterEncoding();    
    public String getUserAgent();
    public Map<String, String> getCookies();
	public List <Newsitem> parseContent(String content) throws Exception;
	public String getPageURL(String urlstub);
	
}
