package nz.gen.wellington.screenscrapers.auckland;

import java.util.ArrayList;
import java.util.List;

import nz.gen.wellington.screenscrapers.Newsitem;
import nz.gen.wellington.screenscrapers.NewsitemImpl;
import nz.gen.wellington.screenscrapers.ScreenScraperImpl;

import org.apache.commons.lang.StringEscapeUtils;
import org.htmlparser.Node;
import org.htmlparser.NodeFilter;
import org.htmlparser.Parser;
import org.htmlparser.Tag;
import org.htmlparser.util.NodeList;
import org.htmlparser.util.ParserException;

public class AucklandAirportScraper extends ScreenScraperImpl {

    
    public String getPageURL() {
        return "http://www.auckland-airport.co.nz/NewsHistory/press_releases.php";
    }

    
    
    public List <Newsitem> parseContent(String content) {

        List <Newsitem> newsItems = new ArrayList<Newsitem>();
        Parser parser = new Parser();

        try {
            parser.setInputHTML(content);

            // /NewsHistory/press_releases.php
            parser.setInputHTML(content);
            NodeFilter linkFilter = new org.htmlparser.filters.LinkRegexFilter("/NewsHistory/press_releases.php\\?rid*");
            NodeList linkList = parser.extractAllNodesThatMatch(linkFilter);

            for (int i = 0; i < linkList.size(); i++) {
                Newsitem newsitem = new NewsitemImpl();

                Tag tag = (Tag) linkList.elementAt(i);
                String url = "http://www.auckland-airport.co.nz" + tag.getAttribute("href");
                newsitem.setUrl(url);

                Node descriptionTag = (Node) tag.getPreviousSibling();
                newsitem.setDescription(descriptionTag.toPlainTextString().trim());

                newsitem.setTitle(tag.getParent().getParent().getPreviousSibling().getFirstChild().toPlainTextString());

                String dateString = StringEscapeUtils.unescapeHtml(tag.getParent().getParent().getPreviousSibling().getPreviousSibling().toPlainTextString());
                dateString = dateString.substring(0, dateString.length() - 13);
                newsitem.setDate(parseDate(dateString, "dd MMMM yyyy"));
                
                newsItems.add(newsitem);
            }

        } catch (ParserException e) {
            //  log.error("ParserException: " + e.getMessage());
        }

        return newsItems;
    }

    

}
