package nz.gen.wellington.screenscrapers.isleofwight;

import java.util.ArrayList;
import java.util.List;

import nz.gen.wellington.screenscrapers.Newsitem;
import nz.gen.wellington.screenscrapers.NewsitemImpl;
import nz.gen.wellington.screenscrapers.ResolvableScreenScraper;
import nz.gen.wellington.screenscrapers.ScreenScraperImpl;

import org.htmlparser.Node;
import org.htmlparser.Tag;
import org.htmlparser.util.NodeList;

public class IOWCPlanningApplicationsScraper extends ScreenScraperImpl implements ResolvableScreenScraper {

	private static final String URL_PREFIX = "http://www.iwight.com/council/departments/planning/appsdip/";

	public String getUrlStub() {
		return "iow-planning-applications";
	}
	
	public String getPageURL() {
		return URL_PREFIX + "PlanAppSearch.aspx?__EVENTTARGET=lnkShowAll";
	}
	
	public String getCharacterEncoding() {
		return "UTF-8";
	}
	
	public List<Newsitem> parseContent(String content) throws Exception {
		List<Newsitem> newsitems = new ArrayList<Newsitem>();
		NodeList links = this.extractTagsByClassName(content, "dbResults");
		for (int i = 0; i < links.size(); i++) {
			Tag resultsRowDiv = (Tag) links.elementAt(i);
			Tag linkTag = (Tag) resultsRowDiv.getFirstChild().getNextSibling().getFirstChild();
			
			Newsitem newsitem = new NewsitemImpl();
			newsitem.setTitle(linkTag.toPlainTextString().replaceAll("\\s+", " ").trim());
			newsitem.setUrl(URL_PREFIX + linkTag.getAttribute("href"));			
			Node locationTag = linkTag.getParent().getNextSibling();
			final String location = locationTag.toPlainTextString().replaceAll("\\s+", " ").trim();
			Node descriptionTag = locationTag.getNextSibling();
			newsitem.setDescription(location + ". " + descriptionTag.toPlainTextString().replaceAll("\\s+", " ").trim());
			newsitems.add(newsitem);
		}
				
		return newsitems;
	}

}
