package nz.gen.wellington.screenscrapers.wellington;

import java.util.ArrayList;
import java.util.List;

import nz.gen.wellington.screenscrapers.Newsitem;
import nz.gen.wellington.screenscrapers.NewsitemImpl;
import nz.gen.wellington.screenscrapers.ResolvableScreenScraper;
import nz.gen.wellington.screenscrapers.ScreenScraperImpl;

import org.htmlparser.Node;
import org.htmlparser.Tag;
import org.htmlparser.util.NodeList;

public class FringeScraper extends ScreenScraperImpl implements ResolvableScreenScraper {

	private static final String URL_PREFIX = "http://www.fringe.org.nz";

	public String getPageURL() {
		return "http://www.fringe.org.nz/news-and-media/";
	}

	public String getUrlStub() {
		return "fringe";
	}
	
	public List<Newsitem> parseContent(String content) throws Exception {
		List<Newsitem> newsitems = new ArrayList<Newsitem>();
        
		Node newsList = this.extractTagByClassName(content, "blog_listing");
		NodeList listElements = this.extractTagsByClassName(newsList.toHtml(), "blog_title");
			
		for (int i = 0; i < listElements.size(); i++) {		
			Newsitem newsitem = new NewsitemImpl();			
			Tag title = (Tag) listElements.elementAt(i);
			newsitem.setTitle(title.getFirstChild().toPlainTextString().trim());
			newsitem.setUrl(URL_PREFIX + ((Tag) title.getFirstChild()).getAttribute("href").trim());
			
			final String dateString = title.getPreviousSibling().toPlainTextString();
			newsitem.setDate(this.parseDate(dateString, "dd MMMMM, yyyy"));						
			newsitem.setDescription(title.getNextSibling().getFirstChild().toPlainTextString());
	        newsitems.add(newsitem);
		}		
		return newsitems;
	}

}
