package nz.gen.wellington.screenscrapers.wellington;

import java.util.ArrayList;
import java.util.List;

import nz.gen.wellington.screenscrapers.Newsitem;
import nz.gen.wellington.screenscrapers.NewsitemImpl;
import nz.gen.wellington.screenscrapers.ResolvableScreenScraper;
import nz.gen.wellington.screenscrapers.ScreenScraperImpl;

import org.htmlparser.Tag;
import org.htmlparser.util.NodeList;

public class HOBMScraper extends ScreenScraperImpl implements ResolvableScreenScraper {
	
	public String getUrlStub() {
		return "hobm";
	}

	public String getCharacterEncoding() {
		return "UTF-8";
	}
	
	public String getPageURL() {
		return "http://hobm.co.nz/news-events/";
	}
	
	@Override
	public String getName() {
		return "Hutt Old Boys Marist Rugby Football Club news";
	}

	public List<Newsitem> parseContent(String content) throws Exception {		
		List<Newsitem> newsitems = new ArrayList<Newsitem>();
		Tag mainPanel = extractTagByClassName(content, "overlay-green-stripe");		
		NodeList links = this.extractTagsByClassName(mainPanel.toHtml(), "NewsSummary");
		for (int i = 0; i < links.size(); i++) {
			Tag newsitemDiv = (Tag) links.elementAt(i);
						
			Tag link = this.extractTagByClassName(newsitemDiv.toHtml(), "MW6");			
			Newsitem newsitem = new NewsitemImpl();
			
			newsitem.setTitle(link.toPlainTextString());
			newsitem.setUrl(link.getAttribute("href"));
			
			String dateString = this.extractTagByClassName(newsitemDiv.toHtml(), "NewsSummaryPostdate").toPlainTextString().trim();
			dateString = dateString.substring(0, 8);
			newsitem.setDate(this.parseDate(dateString, "dd/MM/yy"));
			
			newsitem.setDescription(this.extractTagByClassName(newsitemDiv.toHtml(), "NewsSummarySummary").toPlainTextString().trim());
			newsitems.add(newsitem);
		}
		return newsitems;
	}

}
