package nz.gen.wellington.screenscrapers.wellington;

import java.util.ArrayList;
import java.util.List;

import nz.gen.wellington.screenscrapers.Newsitem;
import nz.gen.wellington.screenscrapers.NewsitemImpl;
import nz.gen.wellington.screenscrapers.ResolvableScreenScraper;
import nz.gen.wellington.screenscrapers.ScreenScraperImpl;

import org.htmlparser.Tag;
import org.htmlparser.util.NodeList;

public class JCCScraper extends ScreenScraperImpl implements ResolvableScreenScraper {
		
	@Override
	public String getCharacterEncoding() {
		return "UTF-8";
	}

	public String getPageURL() {
		return "http://www.jcc.org.nz/";
	}

	public List<Newsitem> parseContent(String content) throws Exception {		
		List<Newsitem> newsitems = new ArrayList<Newsitem>();
		NodeList options = extractTagsByClassName(content, "NewsSummary");
		for (int i = 0; i < options.size(); i++) {
			Tag tag = (Tag) options.elementAt(i);
			Newsitem newsitem = new NewsitemImpl();

			Tag headlineDiv = extractTagByClassName(tag.toHtml(), "NewsSummaryLink");
			Tag headlineLink = (Tag) headlineDiv.getFirstChild().getNextSibling();

			newsitem.setTitle(headlineLink.toPlainTextString().trim());
			newsitem.setUrl(headlineLink.getAttribute("href"));

			Tag summaryDiv = extractTagByClassName(tag.toHtml(), "NewsSummarySummary");
			newsitem.setDescription(summaryDiv.toPlainTextString().trim());
			
			final String dateString = extractTagByClassName(tag.toHtml(), "NewsSummaryPostdate").toPlainTextString().trim();
			newsitem.setDate(parseDate(dateString, "dd/MM/yyyy HH:mm:ss"));			
			newsitems.add(newsitem);
		}
		return newsitems;
	}
	
	public String getUrlStub() {
		return "jcc";
	}

}
