package nz.gen.wellington.screenscrapers.wellington;

import java.util.ArrayList;
import java.util.List;

import nz.gen.wellington.screenscrapers.Newsitem;
import nz.gen.wellington.screenscrapers.NewsitemImpl;
import nz.gen.wellington.screenscrapers.ResolvableScreenScraper;
import nz.gen.wellington.screenscrapers.ScreenScraperImpl;

import org.apache.commons.lang.StringEscapeUtils;
import org.htmlparser.Node;
import org.htmlparser.Tag;
import org.htmlparser.util.NodeList;

public class PetoneRugbyNewsScraper extends ScreenScraperImpl implements ResolvableScreenScraper {

	private static final String DATE_FORMAT = "dd MMMMM yyyy";

	public String getCharacterEncoding() {
		return "UTF-8";
	}
	
	public String getPageURL() {
		return "http://www.petonerugby.com/news/";
	}
	
	public List<Newsitem> parseContent(String content) throws Exception {
		List<Newsitem> newsitems = new ArrayList<Newsitem>();
		NodeList links = extractTagsByClassName(content, "news_post_info");
		for (int i = 0; i < links.size(); i++) {
			Tag div = (Tag) links.elementAt(i);			
			final Newsitem newsitem = new NewsitemImpl();
			Node title = div.getFirstChild().getNextSibling();
			newsitem.setTitle(StringEscapeUtils.unescapeHtml(title.toPlainTextString().trim()));
			
			final Tag link = (Tag) title.getFirstChild();
			newsitem.setUrl("http://www.petonerugby.com" + link.getAttribute("href"));
			
			final Node date = title.getNextSibling().getNextSibling();
			newsitem.setDate(parseDate(date.toPlainTextString(), DATE_FORMAT));
			
			String description = date.getNextSibling().getNextSibling().toPlainTextString().trim();
			description = description.replace("Read more", "").trim();
			newsitem.setDescription(StringEscapeUtils.unescapeHtml(description));
			newsitems.add(newsitem);
		}
		return newsitems;
	}

	public String getUrlStub() {
		return "petone-rugby-news";
	}

}
