package nz.gen.wellington.screenscrapers.wellington;

import java.util.ArrayList;
import java.util.List;

import nz.gen.wellington.screenscrapers.Newsitem;
import nz.gen.wellington.screenscrapers.NewsitemImpl;
import nz.gen.wellington.screenscrapers.ResolvableScreenScraper;
import nz.gen.wellington.screenscrapers.ScreenScraperImpl;

import org.apache.commons.lang.StringEscapeUtils;
import org.htmlparser.Tag;
import org.htmlparser.util.NodeList;

public class PoliceNewsScraper extends ScreenScraperImpl implements ResolvableScreenScraper {

    public String getPageURL() {
        return "http://www.police.govt.nz/district/wellington/news.html";
    }
    
    public String getUrlStub() {
		return "policenews";
	}

	public List<Newsitem> parseContent(String content) throws Exception {
        List<Newsitem> newsitems = new ArrayList<Newsitem>();
        
        NodeList list = this.extractTagsByClassName(content, "views-field-title");         
        for (int i = 0; i < list.size(); i++) {
            Newsitem newsitem = new NewsitemImpl();
            Tag titleTag = (Tag) list.elementAt(i);
                       
            final String title = StringEscapeUtils.unescapeHtml(titleTag.toPlainTextString().trim());
            newsitem.setTitle(title);

            Tag linkTag = (Tag) titleTag.getFirstChild().getNextSibling().getFirstChild();
            newsitem.setUrl("http://www.police.govt.nz" + linkTag.getAttribute("href"));
            newsitems.add(newsitem);
            
            Tag descriptionTag = (Tag) titleTag.getNextSibling().getNextSibling().getFirstChild().getNextSibling();
            newsitem.setDescription(descriptionTag.toPlainTextString());
        }
        
        return newsitems;
    }

}
