package nz.gen.wellington.screenscrapers.wellington;

import java.util.ArrayList;
import java.util.List;

import nz.gen.wellington.screenscrapers.Newsitem;
import nz.gen.wellington.screenscrapers.NewsitemImpl;
import nz.gen.wellington.screenscrapers.ResolvableScreenScraper;
import nz.gen.wellington.screenscrapers.ScreenScraperImpl;

import org.apache.commons.lang.StringEscapeUtils;
import org.htmlparser.Node;
import org.htmlparser.Tag;
import org.htmlparser.util.NodeList;

public class PonekeScraper extends ScreenScraperImpl implements ResolvableScreenScraper {
	
	public String getUrlStub() {
		return "poneke";
	}
	
	public String getPageURL() {
		return "http://ponekerugby.com/poneke-football-club/";
	}
	
	public List<Newsitem> parseContent(String content) throws Exception {
		  List<Newsitem> newsitems = new ArrayList<Newsitem>();
		  		  
		  NodeList bdDivs = this.extractTagsByClassName(content, "bd");
		  Node newsItemsDiv = bdDivs.elementAt(1);		  
		  NodeList newsItemsDivs = this.extractTagsByClassName(newsItemsDiv.toHtml(), "item");		  
		  for (int i = 0; i < newsItemsDivs.size(); i++) {
	            Newsitem newsitem = new NewsitemImpl();
	            Tag div = (Tag) newsItemsDivs.elementAt(i);	            
	            Node headingTag = div.getFirstChild().getNextSibling();
		            
	            newsitem.setTitle(headingTag.getFirstChild().toPlainTextString().trim());
	            
	            Node dateSpan = headingTag.getFirstChild().getNextSibling();
				String dateString = dateSpan.toPlainTextString();
				dateString = dateString.split(" ")[1];
				newsitem.setDate(parseDate(dateString, "dd/MM/yy"));
				
	            Node bodyTag = headingTag.getNextSibling().getNextSibling();				
				Tag moreLink = (Tag) this.extractTagByClassName(bodyTag.toHtml(), "more");
				newsitem.setUrl(StringEscapeUtils.unescapeHtml(moreLink.getAttribute("href")));				
				newsitem.setDescription(bodyTag.toPlainTextString().replaceAll("more$", ""));
				
				newsitems.add(newsitem);
		  }		  
		  return newsitems;
	}

}
