package nz.gen.wellington.screenscrapers.wellington;

import java.util.ArrayList;
import java.util.List;

import nz.gen.wellington.screenscrapers.Newsitem;
import nz.gen.wellington.screenscrapers.NewsitemImpl;
import nz.gen.wellington.screenscrapers.ResolvableScreenScraper;
import nz.gen.wellington.screenscrapers.ScreenScraperImpl;

import org.apache.commons.lang.StringEscapeUtils;
import org.htmlparser.Tag;
import org.htmlparser.util.NodeList;

public class RPNYCScraper extends ScreenScraperImpl implements ResolvableScreenScraper {
	
	public String getUrlStub() {
		return "rpnyc";
	}
	
	public String getCharacterEncoding() {
		return "UTF-8";
	}

	public String getPageURL() {
		return "http://www.rpnyc.org.nz/index.php?option=com_content&task=blogcategory&id=0&Itemid=216";
	}

	public List<Newsitem> parseContent(String content) throws Exception {
        List<Newsitem> newsitems = new ArrayList<Newsitem>();
        NodeList headings = this.extractTagsByClassName(content, "contentpagetitle");
        for (int i = 0; i < headings.size(); i++) {
        	Newsitem newsitem = new NewsitemImpl();
        	
        	Tag headingLink = (Tag) headings.elementAt(i);        	
        	newsitem.setTitle(headingLink.toPlainTextString().trim());
        	newsitem.setUrl(StringEscapeUtils.unescapeHtml(headingLink.getAttribute("href")));

        	Tag dateTag = extractTagByClassName(headingLink.getParent().getParent().getParent().getNextSibling().getNextSibling().toHtml(), "createdate");
        	final String dateString = dateTag.toPlainTextString().trim().split(",")[1];
        	newsitem.setDate(this.parseDate(dateString, "dd MMMMM yyyy"));
            newsitems.add(newsitem);
        }
        
        return newsitems;
    }

}
