package nz.gen.wellington.screenscrapers.wellington;

import java.util.ArrayList;
import java.util.List;

import nz.gen.wellington.screenscrapers.Newsitem;
import nz.gen.wellington.screenscrapers.NewsitemImpl;
import nz.gen.wellington.screenscrapers.ResolvableScreenScraper;
import nz.gen.wellington.screenscrapers.ScreenScraperImpl;

import org.htmlparser.Node;
import org.htmlparser.Tag;
import org.htmlparser.util.NodeList;

public class SaintsScraper extends ScreenScraperImpl implements ResolvableScreenScraper {
	
	private static final String URL_PREFIX = "http://www.saints.co.nz";
	
	public String getPageURL() {
		return "http://www.saints.co.nz/page/news.aspx";
	}

	public List<Newsitem> parseContent(String content) throws Exception {
		List<Newsitem> newsitems = new ArrayList<Newsitem>();
		Node newsDiv = this.extractTagByClassName(content, "news-viewer news-main");
		
		NodeList nodes = this.extractTagsByClassName(newsDiv.toHtml(), "item");		
		for (int i = 0; i < nodes.size(); i++) {
			NewsitemImpl newsitem = new NewsitemImpl();
            Tag item = (Tag) nodes.elementAt(i);
            
            Node dateNode = item.getFirstChild().getNextSibling().getNextSibling().getNextSibling();
            newsitem.setDate(this.parseDate(dateNode.toPlainTextString(), "dd MMM yyyy"));
            Tag titleNode = (Tag) dateNode.getNextSibling().getNextSibling().getFirstChild();
            newsitem.setTitle(titleNode.toPlainTextString());
            newsitem.setUrl(URL_PREFIX + titleNode.getAttribute("href"));
            
            Node descriptionNode = titleNode.getParent().getNextSibling().getNextSibling();
            newsitem.setDescription(descriptionNode.toPlainTextString().trim());
         	newsitems.add(newsitem);
		}
		return newsitems;
	}

	public String getUrlStub() {
		return "saints";
	}

}
