package nz.gen.wellington.screenscrapers.wellington;

import java.util.ArrayList;
import java.util.List;

import nz.gen.wellington.screenscrapers.Newsitem;
import nz.gen.wellington.screenscrapers.NewsitemImpl;
import nz.gen.wellington.screenscrapers.ScreenScraper;
import nz.gen.wellington.screenscrapers.ScreenScraperImpl;

import org.htmlparser.NodeFilter;
import org.htmlparser.Parser;
import org.htmlparser.Tag;
import org.htmlparser.filters.LinkRegexFilter;
import org.htmlparser.util.NodeList;
import org.htmlparser.util.ParserException;

public class ScorchingScraper extends ScreenScraperImpl implements ScreenScraper {

    private static final String URL_PREFIX = "http://du.scorching.co.nz/";

    public String getPageURL() {
        return "http://du.scorching.co.nz/default.asp?PageID=3470";
    }

    public List<Newsitem> parseContent(String content) throws ParserException {
        List<Newsitem> newsitems = new ArrayList<Newsitem>();
        Parser parser = new Parser();

        content = stripHtmlComments(content);
        parser.setInputHTML(content);
        // TODO Is this really the best urls they have; offset is not permalinkable.
        NodeFilter linkFilter = new LinkRegexFilter(".*PageID=3470&view=item&offset.*");
        NodeList list = parser.extractAllNodesThatMatch(linkFilter);

        for (int i = 0; i < list.size(); i++) {
            Newsitem newsitem = new NewsitemImpl();

            Tag tag = (Tag) list.elementAt(i);
            newsitem.setTitle(tag.toPlainTextString().trim());
            newsitem.setUrl(URL_PREFIX + tag.getAttribute("href"));

            newsitems.add(newsitem);
        }

        return newsitems;

    }

}
