package nz.gen.wellington.screenscrapers.wellington;

import java.util.ArrayList;
import java.util.List;

import nz.gen.wellington.screenscrapers.Newsitem;
import nz.gen.wellington.screenscrapers.NewsitemImpl;
import nz.gen.wellington.screenscrapers.ResolvableScreenScraper;
import nz.gen.wellington.screenscrapers.ScreenScraperImpl;

import org.htmlparser.Node;
import org.htmlparser.Tag;
import org.htmlparser.util.NodeList;

public class SculptureTrustScraper extends ScreenScraperImpl implements ResolvableScreenScraper {

	public String getUrlStub() {
		return "sculpture-trust";
	}
	
	public String getPageURL() {
		return "http://www.sculpture.org.nz/engine/SID/10062.htm";
	}
	
	@Override
	public String getName() {
		return "Wellington Sculpture Trust news";
	}
	
	public List<Newsitem> parseContent(String content) throws Exception {
		List<Newsitem> newsitems = new ArrayList<Newsitem>();		
		Node dropdown = this.extractTagByClassName(content, "formSelect");		
		NodeList options = this.extractTagsByName(dropdown.toHtml(), "option");
		for (int i = 0; i < options.size(); i++) {
			 Tag tag = (Tag) options.elementAt(i);			
			 if (tag.getAttribute("value") != null) {
				 Newsitem newsitem = new NewsitemImpl();
				 newsitem.setTitle(tag.toPlainTextString().trim());
				 newsitem.setUrl(tag.getAttribute("value"));
				 newsitems.add(newsitem);				 
			 }
		}		
		return newsitems;
	}

}
