package nz.gen.wellington.screenscrapers.wellington;

import java.io.ByteArrayInputStream;
import java.util.ArrayList;
import java.util.List;

import nz.gen.wellington.screenscrapers.Newsitem;
import nz.gen.wellington.screenscrapers.NewsitemImpl;
import nz.gen.wellington.screenscrapers.ResolvableScreenScraper;
import nz.gen.wellington.screenscrapers.ScreenScraperImpl;

import org.htmlparser.Tag;
import org.htmlparser.util.NodeList;

import com.sun.syndication.feed.synd.SyndEntry;
import com.sun.syndication.feed.synd.SyndFeed;
import com.sun.syndication.io.SyndFeedInput;
import com.sun.syndication.io.XmlReader;

public class SilverStreamScraper extends ScreenScraperImpl implements ResolvableScreenScraper {

	public String getUrlStub() {
		return "silverstream";
	}
	
	public String getPageURL() {
		return "http://www.stream.school.nz/index.php?option=com_content&view=category&layout=blog&id=35&Itemid=259&format=feed&type=rss";
	}
	
	@Override
	public String getCharacterEncoding() {
		return "UTF-8";
	}

	public List<Newsitem> parseContent(String content) throws Exception {		
	     List<Newsitem> newsitems = new ArrayList<Newsitem>();
	     
	     ByteArrayInputStream bs = new ByteArrayInputStream(content.getBytes());
	     SyndFeedInput input = new SyndFeedInput();
	     SyndFeed feed = input.build(new XmlReader(bs));
	     
	     for (int i = 0; i < feed.getEntries().size(); i++) {
	    	 Newsitem newsitem = new NewsitemImpl();
	    	 SyndEntry entry = (SyndEntry) feed.getEntries().get(i);
	    	 newsitem.setTitle(entry.getTitle());
	    	 newsitem.setUrl(entry.getUri());
	    	 newsitem.setDate(entry.getPublishedDate());
	    	 
	    	 String htmlDescription = entry.getDescription().getValue();
	    	 htmlDescription = htmlDescription.replaceAll("\ufffd", " ");
	    	 newsitem.setDescription(this.stripHtmlTags(htmlDescription));
	    	 
	    	 NodeList images = this.extractTagsByName(htmlDescription, "img");
	    	 if (images.size() > 0) {
	    		 Tag imageTag = (Tag) images.elementAt(0);
	    		 newsitem.setImage(imageTag.getAttribute("src"));
	    		 newsitem.setImageDescription(imageTag.getAttribute("alt"));
	    	 }
	    	 newsitems.add(newsitem);
	     }	     
	     return newsitems;
	}

}
