package nz.gen.wellington.screenscrapers.wellington;

import java.util.ArrayList;
import java.util.List;

import nz.gen.wellington.screenscrapers.Newsitem;
import nz.gen.wellington.screenscrapers.NewsitemImpl;
import nz.gen.wellington.screenscrapers.ResolvableScreenScraper;
import nz.gen.wellington.screenscrapers.ScreenScraperImpl;

import org.htmlparser.Node;
import org.htmlparser.Tag;
import org.htmlparser.util.NodeList;

public class TranzmetroNewsScraper extends ScreenScraperImpl implements ResolvableScreenScraper {

	public String getCharacterEncoding() {
		return "UTF-8";
	}
	
    public String getUserAgent() {
    	return "Mozilla/5.0 (Windows; U; Windows NT 5.1; en-GB; rv:1.8.1.11) Gecko/20071127 Firefox/2.0.0.11";
    }

	public String getPageURL() {
		return "http://www.tranzmetro.co.nz/Notices.aspx";
	}

	public List<Newsitem> parseContent(String content) throws Exception {
		List<Newsitem> newsitems = new ArrayList<Newsitem>();
	        
		Node newsTable = this.extractTagByClassName(content, "news");
		NodeList headings = this.extractTagsByName(newsTable.toHtml(), "h3");

		for (int i = 0; i < headings.size(); i++) {
			Newsitem newsitem = new NewsitemImpl();			
			Tag headingTag = (Tag) headings.elementAt(i);		
			Tag linkTag = (Tag) headingTag.getFirstChild();
			newsitem.setTitle(linkTag.toPlainTextString().trim());
			newsitem.setUrl(linkTag.getAttribute("href").trim());
			
			Tag descriptionTag = (Tag) headingTag.getNextSibling().getNextSibling();
			newsitem.setDescription(descriptionTag.toPlainTextString().replace("Read&nbsp;more.", "").trim());
	        newsitems.add(newsitem);  
		}	
		return newsitems;
	}

	public String getUrlStub() {
		return "tranzmetro";
	}

}
