package nz.gen.wellington.screenscrapers.wellington;

import java.util.ArrayList;
import java.util.List;

import nz.gen.wellington.screenscrapers.Newsitem;
import nz.gen.wellington.screenscrapers.NewsitemImpl;
import nz.gen.wellington.screenscrapers.ResolvableScreenScraper;
import nz.gen.wellington.screenscrapers.ScreenScraperImpl;

import org.htmlparser.Tag;
import org.htmlparser.util.NodeList;

public class WECCScraper extends ScreenScraperImpl implements ResolvableScreenScraper {
	
	public String getUrlStub() {
		return "wecc";
	}
	
	public String getCharacterEncoding() {
		return "UTF-8";
	}

	public String getPageURL() {
		return "http://www.wecc.org.nz/news-and-info";
	}
	
	@Override
	public String getName() {
		return "Wellington Employers' Chamber of Commerce news";
	}

	public List<Newsitem> parseContent(String content) throws Exception {
        List<Newsitem> newsitems = new ArrayList<Newsitem>();

        NodeList newsitemDivs = extractTagsByClassName(content, "np-iteminfo");
        for (int i = 0; i < newsitemDivs.size(); i++) {
        	Newsitem newsitem = new NewsitemImpl();        	
        	Tag newsitemDiv = (Tag) newsitemDivs.elementAt(i);
        	
        	Tag heading = (Tag) this.extractTagsByName(newsitemDiv.toHtml(), "h3").elementAt(0);       	
        	newsitem.setTitle(heading.toPlainTextString());
        	newsitem.setUrl(((Tag) heading.getFirstChild()).getAttribute("href"));
        	
        	String dateString = extractTagByClassName(newsitemDiv.toHtml(), "published").toPlainTextString();
        	dateString = dateString.replaceFirst(".*?(\\d)", "$1");
        	dateString = dateString.replaceFirst(" from.*$", "");
        	dateString = dateString.replaceFirst("(\\d+).*? ", "$1 ");
        	newsitem.setDate(parseDate(dateString, "d MMM yyyy"));
        	
            newsitems.add(newsitem);
        }        
        return newsitems;
    }

}
