package nz.gen.wellington.screenscrapers.wellington;

import java.util.ArrayList;
import java.util.List;

import nz.gen.wellington.screenscrapers.Newsitem;
import nz.gen.wellington.screenscrapers.NewsitemImpl;
import nz.gen.wellington.screenscrapers.ResolvableScreenScraper;
import nz.gen.wellington.screenscrapers.ScreenScraperImpl;

import org.htmlparser.Tag;
import org.htmlparser.util.NodeList;

public class WatersideKaroriScraper extends ScreenScraperImpl implements ResolvableScreenScraper {

	private static final String URL_PREFIX = "http://www.watersidekaroriafc.org.nz/";

	public String getUrlStub() {
		return "watersidekarori";
	}
	
	public String getCharacterEncoding() {
		return "UTF-8";
	}

	public String getPageURL() {
		return URL_PREFIX + "reports.asp";
	}
	
	public List<Newsitem> parseContent(String content) throws Exception {
		List<Newsitem> newsitems = new ArrayList<Newsitem>();
		
		NodeList nodes = this.extractTagsByName(content, "h2");
		
		for (int i = 0; i < nodes.size(); i++) {
			NewsitemImpl newsitem = new NewsitemImpl();
            Tag heading = (Tag) nodes.elementAt(i);
            
            newsitem.setTitle(heading.toPlainTextString());
            Tag headingLink = (Tag) heading.getFirstChild();            
            newsitem.setUrl(URL_PREFIX + headingLink.getAttribute("href"));
            
         	final String dateString = this.extractTagsByWidth(heading.getParent().toHtml(), "403").toPlainTextString();
         	newsitem.setDate(this.parseDate(dateString, "dd/MM/yyyy"));
         	newsitems.add(newsitem);         	
		}
		return newsitems;
	}
	
}
