package nz.gen.wellington.screenscrapers.wellington;

import java.util.ArrayList;
import java.util.List;

import nz.gen.wellington.screenscrapers.Newsitem;
import nz.gen.wellington.screenscrapers.NewsitemImpl;
import nz.gen.wellington.screenscrapers.ResolvableScreenScraper;
import nz.gen.wellington.screenscrapers.ScreenScraperImpl;

import org.apache.commons.lang.StringEscapeUtils;
import org.htmlparser.Tag;
import org.htmlparser.util.NodeList;

public class WellingtonScoopFeaturesScraper extends ScreenScraperImpl implements ResolvableScreenScraper {

	public String getUrlStub() {
		return "wellington-scoop-features";
	}
	
	public String getPageURL() {
		return "http://wellington.scoop.co.nz/?cat=4,15";
	}
	
	public String getCharacterEncoding() {
		return "UTF-8";
	}


	public List<Newsitem> parseContent(String content) throws Exception {
	     List<Newsitem> newsitems = new ArrayList<Newsitem>();
	     NodeList headings = this.extractTagsByClassName(content, "entry");
	     for (int i = 0; i < headings.size(); i++) {
	    	 Newsitem newsitem = new NewsitemImpl();
	    	 
	    	 Tag entry = (Tag) headings.elementAt(i);
	    	 Tag headingTag = (Tag) this.extractTagByClassName(entry.toHtml(), "entrytitle");
	    	 Tag headlineLink = (Tag) headingTag.getFirstChild().getNextSibling();
	    	 newsitem.setTitle(StringEscapeUtils.unescapeHtml(headlineLink.toPlainTextString()));
	    	 newsitem.setUrl(headlineLink.getAttribute("href"));
	    	 
	    	 String dateString = this.extractTagByClassName(entry.toHtml(), "meta-time").toPlainTextString().trim();	    	 
	    	 dateString = dateString.replace("nd,", ",");
	    	 dateString = dateString.replace("rd,", ",");
	    	 dateString = dateString.replace("st,", ",");
	    	 dateString = dateString.replace("th,", ",");	    	 
	    	 newsitem.setDate(this.parseDate(dateString, "MMMMM dd, yyyy"));
	    	 
	    	 newsitems.add(newsitem);
	     }
	     return newsitems;
	}

}
