package nz.gen.wellington.screenscrapers.wellington;

import java.util.ArrayList;
import java.util.List;

import nz.co.searchwellington.utils.UrlFilters;
import nz.gen.wellington.screenscrapers.Newsitem;
import nz.gen.wellington.screenscrapers.NewsitemImpl;
import nz.gen.wellington.screenscrapers.ResolvableScreenScraper;
import nz.gen.wellington.screenscrapers.ScreenScraperImpl;

import org.htmlparser.NodeFilter;
import org.htmlparser.Parser;
import org.htmlparser.Tag;
import org.htmlparser.filters.HasAttributeFilter;
import org.htmlparser.util.NodeList;
import org.htmlparser.util.ParserException;

public class WellingtonistaCommentScraper extends ScreenScraperImpl implements ResolvableScreenScraper {

	
	public String getUrlStub() {
		return "wellingtonista-comments/.*";
	}
	
	@Override
	public String getPageURL(String urlstub) {
		// TODO validation
		return "http://www.wellingtonista.com/"  + urlstub.split("/")[1];
	}
	
	public String getPageURL() {
		throw new UnsupportedOperationException();
	}
	
	public List<Newsitem> parseContent(String content) throws Exception {
		List<Newsitem> comments = new ArrayList<Newsitem>();	
		
	    Parser parser = new Parser();
	    content = stripHtmlComments(content);
        parser.setInputHTML(content);
        NodeFilter filterNode = new HasAttributeFilter("class", "comment");    
        NodeList list = parser.extractAllNodesThatMatch(filterNode);
        
        for (int i = 0; i < list.size(); i++) {        	
        	Newsitem newsitem = new NewsitemImpl();
            Tag tag = (Tag) list.elementAt(i);           
            extractCommentContentFromCommentDiv(newsitem, tag);			
            comments.add(newsitem);        	
        }
        
		return comments;
		
	}

		
	private void extractCommentContentFromCommentDiv(Newsitem newsitem, Tag tag) throws ParserException {
		Parser commentParser = new Parser();
		commentParser.setInputHTML(tag.toHtml());
		NodeFilter commentFilterNode = new HasAttributeFilter("class", "content");    
		NodeList commentContentList = commentParser.extractAllNodesThatMatch(commentFilterNode);
		
		Tag commentContentTag = (Tag) commentContentList.elementAt(0);        
		newsitem.setTitle(UrlFilters.stripHtmlTags(commentContentTag.toPlainTextString()));
	}

}
