package nz.gen.wellington.screenscrapers.wellington;

import java.util.ArrayList;
import java.util.List;

import nz.gen.wellington.screenscrapers.Newsitem;
import nz.gen.wellington.screenscrapers.NewsitemImpl;
import nz.gen.wellington.screenscrapers.ResolvableScreenScraper;
import nz.gen.wellington.screenscrapers.ScreenScraperImpl;

import org.htmlparser.Node;
import org.htmlparser.Tag;
import org.htmlparser.util.NodeList;

public class WhitireiaScraper extends ScreenScraperImpl implements ResolvableScreenScraper {

	public String getUrlStub() {
		return "whitireia";
	}
	
	public String getPageURL() {
		return "http://www.whitireia.ac.nz/news/Pages/HomePage.aspx";
	}

	public List<Newsitem> parseContent(String content) throws Exception {	
		List<Newsitem> newsitems = new ArrayList<Newsitem>();		
		Node newsListingsDiv = this.extractTagByClassName(content, "news-listings");		
		
		NodeList items = this.extractTagsByClassName(newsListingsDiv.toHtml(), "content-full");		
		for (int i = 0; i < items.size(); i++) {
			 Tag tag = (Tag) items.elementAt(i);
			 Newsitem newsitem = new NewsitemImpl();
			 Tag linkTag = (Tag) tag.getFirstChild().getNextSibling().getFirstChild();
			 newsitem.setTitle(linkTag.toPlainTextString().trim());			 
			 newsitem.setUrl(linkTag.getAttribute("href"));
			 
			 Tag dateNode = this.extractTagByClassName(tag.toHtml(), "date");
			 final String dateString = dateNode.getNextSibling().toPlainTextString();
			 newsitem.setDate(this.parseDate(dateString, "d MMMMM yyyy"));
			 
			 Node descriptionNode = dateNode.getNextSibling().getNextSibling().getNextSibling().getNextSibling();
			 newsitem.setDescription(descriptionNode.toPlainTextString().trim());			 
			 newsitems.add(newsitem);
		}		
		
		return newsitems;
	}

}
