package nz.gen.wellington.screenscrapers.westisland;

import java.io.StringReader;
import java.util.ArrayList;
import java.util.List;

import nz.co.searchwellington.utils.CachingHttpFetcher;
import nz.gen.wellington.screenscrapers.Newsitem;
import nz.gen.wellington.screenscrapers.NewsitemImpl;
import nz.gen.wellington.screenscrapers.ResolvableScreenScraper;
import nz.gen.wellington.screenscrapers.ScreenScraperImpl;

import org.htmlparser.Node;
import org.htmlparser.util.ParserException;

import com.sun.syndication.feed.synd.SyndEntry;
import com.sun.syndication.feed.synd.SyndFeed;
import com.sun.syndication.io.SyndFeedInput;

public class TheAgeScraper extends ScreenScraperImpl implements ResolvableScreenScraper {
	
	CachingHttpFetcher httpFetcher;
	
	public TheAgeScraper(CachingHttpFetcher httpFetcher) {
		this.httpFetcher = httpFetcher;
	}
	
	public String getUrlStub() {
		return "theage";
	}
	
	public String getPageURL() {
		return "http://feeds.theage.com.au/rssheadlines/national.xml";
	}
	
	public List<Newsitem> parseContent(String content) throws Exception {
		List<Newsitem> newsitems = new ArrayList<Newsitem>();
		
		StringReader reader = new StringReader(content);
		
		SyndFeedInput syndFeedInput = new SyndFeedInput();
		SyndFeed feed = syndFeedInput.build(reader);
		
		for (Object entry : feed.getEntries()) {
			SyndEntry item = (SyndEntry) entry;
 			Newsitem newsitem = new NewsitemImpl();
 			newsitem.setTitle(item.getTitle());
 			newsitem.setUrl(item.getLink());
 			newsitem.setDate(item.getPublishedDate());
 			newsitems.add(newsitem);
 			
 			getFullBody(newsitem);
		}
		
		return newsitems;
	}

	
	private void getFullBody(Newsitem newsitem) throws ParserException {
		String pageContent = httpFetcher.httpFetch(newsitem.getUrl(), "ISO-8859-1", null, null);
		Node bodyDiv = this.extractTagByClassName(pageContent, "articleBody");
		newsitem.setDescription(bodyDiv.toHtml());	
	}

}
