package nz.gen.wellington.servlets.screenscrapers;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import nz.gen.wellington.screenscrapers.ResolvableScreenScraper;

import com.google.inject.Inject;
import com.google.inject.Singleton;

@SuppressWarnings("serial")
@Singleton
public class IndexServlet extends HttpServlet {

	private ResolveableFeedDAO feedDAO;
		
	@Inject
	 public IndexServlet(ResolveableFeedDAO feedDAO) {	
		this.feedDAO = feedDAO;
	}

	@Override
	 public void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		resp.setContentType("text/html");
		PrintWriter writer = resp.getWriter();
		 
		for (ResolvableScreenScraper scraper : feedDAO.getScrapers()) {
			boolean isCommentScraper = scraper.getUrlStub().contains("/");
			if (!isCommentScraper) {
				writer.print("<li><a href=\"feeds/" + scraper.getUrlStub() + "\">" + scraper.getUrlStub() + "</a> - " + scraper.getPageURL() + "</li>");
			}
		}
		writer.flush();
	}
	
}
