package nz.gen.wellington.servlets.screenscrapers;

import java.util.ArrayList;
import java.util.List;

import nz.co.searchwellington.utils.CachingHttpFetcher;
import nz.gen.wellington.screenscrapers.ResolvableScreenScraper;
import nz.gen.wellington.screenscrapers.isleofwight.IOWCPlanningApplicationsScraper;
import nz.gen.wellington.screenscrapers.twickenham.LBRUTPlanningApplicationsScraper;
import nz.gen.wellington.screenscrapers.twickenham.MogdenScraper;
import nz.gen.wellington.screenscrapers.wellington.CCDHBScraper;
import nz.gen.wellington.screenscrapers.wellington.CapitalFootballScraper;
import nz.gen.wellington.screenscrapers.wellington.CatsProtectionLeagueScraper;
import nz.gen.wellington.screenscrapers.wellington.CityGalleryScraper;
import nz.gen.wellington.screenscrapers.wellington.ClubWeeklyScraper;
import nz.gen.wellington.screenscrapers.wellington.CricketWellingtonScraper;
import nz.gen.wellington.screenscrapers.wellington.FringeScraper;
import nz.gen.wellington.screenscrapers.wellington.HOBMScraper;
import nz.gen.wellington.screenscrapers.wellington.JCCScraper;
import nz.gen.wellington.screenscrapers.wellington.KaroriCricketScraper;
import nz.gen.wellington.screenscrapers.wellington.KaroriSanctuaryScraper;
import nz.gen.wellington.screenscrapers.wellington.NorthernCourierScraper;
import nz.gen.wellington.screenscrapers.wellington.OlympicAFCScraper;
import nz.gen.wellington.screenscrapers.wellington.PCCScraper;
import nz.gen.wellington.screenscrapers.wellington.PetoneHeraldScraper;
import nz.gen.wellington.screenscrapers.wellington.PetoneRugbyMatchReportsScraper;
import nz.gen.wellington.screenscrapers.wellington.PetoneRugbyNewsScraper;
import nz.gen.wellington.screenscrapers.wellington.PhoenixScraper;
import nz.gen.wellington.screenscrapers.wellington.PoliceNewsScraper;
import nz.gen.wellington.screenscrapers.wellington.PonekeScraper;
import nz.gen.wellington.screenscrapers.wellington.RPNYCScraper;
import nz.gen.wellington.screenscrapers.wellington.SaintsScraper;
import nz.gen.wellington.screenscrapers.wellington.SculptureTrustScraper;
import nz.gen.wellington.screenscrapers.wellington.SilverStreamScraper;
import nz.gen.wellington.screenscrapers.wellington.SistersOfCompassionScraper;
import nz.gen.wellington.screenscrapers.wellington.TranzmetroNewsScraper;
import nz.gen.wellington.screenscrapers.wellington.UnitedFutureScraper;
import nz.gen.wellington.screenscrapers.wellington.WECCScraper;
import nz.gen.wellington.screenscrapers.wellington.WatersideKaroriScraper;
import nz.gen.wellington.screenscrapers.wellington.WellingtonAirportScraper;
import nz.gen.wellington.screenscrapers.wellington.WellingtonBasketballAssociationScraper;
import nz.gen.wellington.screenscrapers.wellington.WellingtonChildrensHospitalScraper;
import nz.gen.wellington.screenscrapers.wellington.WellingtonLionsScraper;
import nz.gen.wellington.screenscrapers.wellington.WellingtonScoopFeaturesScraper;
import nz.gen.wellington.screenscrapers.wellington.WellingtonistaCommentScraper;
import nz.gen.wellington.screenscrapers.wellington.WhitireiaScraper;
import nz.gen.wellington.screenscrapers.westisland.TheAgeScraper;

import com.google.inject.Inject;

public class ResolveableFeedDAO {

	private List<ResolvableScreenScraper> scrapers;
		
	@Inject
	public ResolveableFeedDAO(CachingHttpFetcher httpFetcher) {		
		scrapers = new ArrayList<ResolvableScreenScraper>();
		
		// TODO can this be done by reflection?
		scrapers.add(new CatsProtectionLeagueScraper());
		scrapers.add(new CCDHBScraper());
		scrapers.add(new CapitalFootballScraper());
		scrapers.add(new CityGalleryScraper());
		scrapers.add(new ClubWeeklyScraper());
		scrapers.add(new CricketWellingtonScraper());
		scrapers.add(new FringeScraper());
		scrapers.add(new HOBMScraper());
		scrapers.add(new IOWCPlanningApplicationsScraper());
		scrapers.add(new JCCScraper());
		scrapers.add(new KaroriSanctuaryScraper());
		scrapers.add(new KaroriCricketScraper());
		scrapers.add(new LBRUTPlanningApplicationsScraper(httpFetcher));
        scrapers.add(new MogdenScraper());
		scrapers.add(new NorthernCourierScraper());
		scrapers.add(new OlympicAFCScraper());
		scrapers.add(new PCCScraper());
		scrapers.add(new PetoneRugbyNewsScraper());
		scrapers.add(new PetoneRugbyMatchReportsScraper());
		scrapers.add(new PetoneHeraldScraper());
		scrapers.add(new PhoenixScraper());
		scrapers.add(new PoliceNewsScraper());
		scrapers.add(new PonekeScraper());
		scrapers.add(new RPNYCScraper());
		scrapers.add(new SaintsScraper());
		scrapers.add(new SculptureTrustScraper());
		scrapers.add(new SilverStreamScraper());		
		scrapers.add(new SistersOfCompassionScraper());
		scrapers.add(new TranzmetroNewsScraper());
		scrapers.add(new TheAgeScraper(httpFetcher));
		scrapers.add(new UnitedFutureScraper());
		scrapers.add(new WatersideKaroriScraper());
		scrapers.add(new WECCScraper());
		scrapers.add(new WellingtonAirportScraper());
		scrapers.add(new WellingtonBasketballAssociationScraper());
		scrapers.add(new WellingtonChildrensHospitalScraper());
		scrapers.add(new WellingtonLionsScraper());
		scrapers.add(new WellingtonScoopFeaturesScraper());
		scrapers.add(new WhitireiaScraper());
		scrapers.add(new WellingtonistaCommentScraper());
	}
	
	public List<ResolvableScreenScraper> getScrapers() {
		return scrapers;
	}
	
}
