package nz.gen.wellington.screenscrapers.wellington;

import java.util.List;

import nz.gen.wellington.screenscrapers.Base;
import nz.gen.wellington.screenscrapers.Newsitem;
import nz.gen.wellington.screenscrapers.ScreenScraper;

public class CricketWellingtonScraperTest extends Base {

	public void testScraper() throws Exception {
		ScreenScraper scraper = new CricketWellingtonScraper();
		StringBuffer content = loadContent("cricket-wellington-news.html");

		List<Newsitem> extractedItems = scraper.parseContent(content.toString());
		assertEquals(10, extractedItems.size());
        
        Newsitem firstItem = extractedItems.get(0);
        assertEquals("Six Blaze players in initial White Ferns T20 World Cup squad", firstItem.getTitle());
        assertEquals("http://www.cricketwellington.co.nz/news/six-blaze-players-in-initial-white-ferns-t20-world-cup-squad/5301/article.aspx", firstItem.getUrl());
        assertEquals("3 Apr 2009", df.format(firstItem.getDate().getTime()));
        assertTrue(firstItem.getDescription().startsWith("The success of the State Wellington Blaze this summer in winning in the State League"));
        assertFalse(firstItem.getDescription().endsWith("after the camp. "));       
	}

}