package nz.gen.wellington.screenscrapers.wellington;

import java.text.SimpleDateFormat;
import java.util.List;

import nz.gen.wellington.screenscrapers.Base;
import nz.gen.wellington.screenscrapers.Newsitem;
import nz.gen.wellington.screenscrapers.ScreenScraper;

public class PetoneRugbyNewsScraperTest extends Base {
	
	protected SimpleDateFormat df;

	protected void setUp() throws Exception {
		df = new SimpleDateFormat();
		df.applyPattern("d MMM yyyy");
	}
	
	public void testScraper() throws Exception {
        ScreenScraper scraper = new PetoneRugbyNewsScraper();
        StringBuffer content = loadContent("petone-rugby-news.html");
        
        List<Newsitem> extractedItems = scraper.parseContent(content.toString());
        assertEquals(5, extractedItems.size());
        Newsitem first = extractedItems.get(0);
        assertEquals("2012 Half Year Report", first.getTitle());
        assertEquals("http://www.petonerugby.com/news/news-archive/display/714/", first.getUrl());
        assertEquals("2 May 2012", df.format(first.getDate().getTime()));
        assertEquals("The 2012 Half Year Report has been released by the PRFC Management Team.", first.getDescription());
    }
	
}
