package nz.gen.wellington.screenscrapers.wellington;

import java.util.List;

import nz.gen.wellington.screenscrapers.Base;
import nz.gen.wellington.screenscrapers.Newsitem;
import nz.gen.wellington.screenscrapers.ScreenScraper;

public class PoliceNewsScraperTests extends Base {

	public void testScraper() throws Exception {
		ScreenScraper scraper = new PoliceNewsScraper();
      	StringBuffer content = loadContent("wellington-police-news.html");

		List<Newsitem> extractedItems = scraper.parseContent(content.toString());
		assertEquals(10, extractedItems.size());
	
		Newsitem firstItem = (Newsitem) extractedItems.get(0);
		assertEquals("Police warn of PIN number scam in Wellington", firstItem.getTitle());
		assertEquals("http://www.police.govt.nz/news/release/22067.html", firstItem.getUrl());
		assertEquals("Wellington Police want to identify two people in relation to a PIN number scam being used to obtain...", firstItem.getDescription());
     }

}