package nz.gen.wellington.screenscrapers.wellington;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.Reader;
import java.text.SimpleDateFormat;
import java.util.List;

import junit.framework.TestCase;
import nz.gen.wellington.screenscrapers.Newsitem;
import nz.gen.wellington.screenscrapers.ScreenScraper;

public class RPNYCScraperTest extends TestCase {
	
	protected SimpleDateFormat df;

	protected void setUp() throws Exception {
		df = new SimpleDateFormat();
		df.applyPattern("d MMM yyyy");
	}

	protected StringBuffer loadContent(String filename) throws IOException {
		StringBuffer content = new StringBuffer();
		File contentFile = new File(ClassLoader.getSystemClassLoader().getResource(filename).getFile());
		Reader freader = new FileReader(contentFile);
		BufferedReader in = new BufferedReader(freader);
		String str;
		while ((str = in.readLine()) != null) {
			content.append(str);
			content.append("\n");
		}
		in.close();
		freader.close();
		return content;
	}
	
	
	public void testScraper() throws Exception {
        ScreenScraper scraper = new RPNYCScraper();
        StringBuffer content = loadContent("rpnyc-news.html");
        
        List<Newsitem> extractedItems = scraper.parseContent(content.toString());
        assertEquals(6, extractedItems.size());
        Newsitem first = extractedItems.get(0);
        assertEquals("Nelson race gets away but not before a false start", first.getTitle());
        assertEquals("http://www.rpnyc.org.nz/index.php?option=com_content&task=view&id=1035&Itemid=216", first.getUrl());
        assertEquals("28 Jan 2010", df.format(first.getDate().getTime()));
    }
	
}
