package nz.gen.wellington.screenscrapers.wellington;

import java.util.List;

import nz.gen.wellington.screenscrapers.Base;
import nz.gen.wellington.screenscrapers.Newsitem;
import nz.gen.wellington.screenscrapers.ScreenScraper;

public class SilverStreamScraperTest extends Base {

	public void testScraper() throws Exception {		
		ScreenScraper scraper = new SilverStreamScraper();
		StringBuffer content = loadContent("silverstream-news.xml");

		List<Newsitem> extractedItems = scraper.parseContent(content.toString());		
		assertEquals(10, extractedItems.size());
        
        Newsitem firstItem = (Newsitem) extractedItems.get(0);
        assertEquals("First XI Takes 2009 Title", firstItem.getTitle());       
        assertEquals("http://www.stream.school.nz/index.php?option=com_content&view=article&id=282:first-xi-takes-2009-title&catid=35:college-news&Itemid=259", firstItem.getUrl());
		assertEquals("23 Aug 2009", df.format(firstItem.getDate().getTime()));
		assertTrue(firstItem.getDescription().startsWith("Saturday 22 August 2009:"));
		assertEquals("http://www.stream.school.nz/images/stories/2009/FirstXI/2009Team.jpg", firstItem.getImage());
		assertEquals("The First XI Football team celebrates after winning the Division 1 Final against Scots 3-1.", firstItem.getImageDescription());
	}
}