package nz.gen.wellington.screenscrapers.wellington;

import java.util.List;

import nz.gen.wellington.screenscrapers.Base;
import nz.gen.wellington.screenscrapers.Newsitem;
import nz.gen.wellington.screenscrapers.ScreenScraper;

import org.joda.time.DateTime;

public class SistersOfCompassionScraperTest extends Base {
	
	public void testSourceUrlShouldMatchTheCurrentYear() throws Exception {
		ScreenScraper scraper = new SistersOfCompassionScraper();		
		DateTime now = new DateTime();		
		assertEquals("http://www.compassion.org.nz/news/" + now.toString("YYYY") + ".php", scraper.getPageURL());
	}

	public void testScraper() throws Exception {
		ScreenScraper scraper = new SistersOfCompassionScraper();
		StringBuffer content = loadContent("compassion-news.html");
		
		List<Newsitem> extractedItems = scraper.parseContent(content.toString());
		assertEquals(13, extractedItems.size());
		
		Newsitem firstItem = (Newsitem) extractedItems.get(0);
		assertEquals("Desmond Ang - A Reflection", firstItem.getTitle());       
		assertEquals("http://www.compassion.org.nz/news/2011.php?subaction=showfull&id=1308219220&archive=&start_from=&ucat=14&", firstItem.getUrl());
		assertTrue(firstItem.getDescription().startsWith("My first thoughts and feelings"));
		assertEquals("16 Jun 2011", df.format(firstItem.getDate().getTime()));
	}
}

