package nz.gen.wellington.screenscrapers.wellington;

import java.util.List;

import nz.gen.wellington.screenscrapers.Base;
import nz.gen.wellington.screenscrapers.Newsitem;
import nz.gen.wellington.screenscrapers.ScreenScraper;

public class WellingtonAirportScraperTest extends Base {

	public void testScraper() throws Exception {
		ScreenScraper scraper = new WellingtonAirportScraper();		
		StringBuffer content = loadContent("airport-news.html");

		List<Newsitem> extractedItems = scraper.parseContent(content.toString());
		assertEquals(13, extractedItems.size());
        
		final Newsitem secondItem = (Newsitem) extractedItems.get(1);

		assertEquals("Wellington Airport returns under Commerce Commission guideline", secondItem.getTitle());
        assertEquals("http://www.wellingtonairport.co.nz/news/wellington-airport-returns-under-commerce-commission-guideline/", secondItem.getUrl());
        assertEquals("11 Jul 2013", df.format(secondItem.getDate().getTime()));        
        assertTrue(secondItem.getDescription().equals("Wellington Airport released its 2013 performance results to the Commerce Commission today. With a return on its aeronautical assets of 6.23%, the airport remains under the Commission’s benchmark of 8% for the third year in a row."));
	}
	
}
