package nz.gen.wellington.screenscrapers.wellington;

import java.util.List;

import nz.gen.wellington.screenscrapers.Base;
import nz.gen.wellington.screenscrapers.Newsitem;
import nz.gen.wellington.screenscrapers.ScreenScraper;

public class WellingtonBasketballAssociationScraperTest extends Base {

	public void testCapitalShakersScraper() throws Exception {
		ScreenScraper capital = new WellingtonBasketballAssociationScraper();
		StringBuffer content = loadContent("wba_front.html");

		List<Newsitem> extractedItems = capital.parseContent(content.toString());
		assertEquals(20, extractedItems.size());
		
		Newsitem firstItem = extractedItems.get(0);
		assertEquals("http://www.wellingtonbasketball.co.nz/cgi-bin/home.pl?news_id=344", firstItem.getUrl());
		assertEquals("WOMENS FIJI TOUR 2008 - DAY 1", firstItem.getTitle());
		assertEquals("7 Apr 2008", df.format(firstItem.getDate().getTime()));
		
		Newsitem secondItemWithDifferentDateFormat = extractedItems.get(1);
		assertEquals("7 Apr 2008", df.format(secondItemWithDifferentDateFormat.getDate().getTime()));
		
	}

}