package nz.gen.wellington.screenscrapers.wellington;

import java.text.SimpleDateFormat;
import java.util.List;

import nz.gen.wellington.screenscrapers.Base;
import nz.gen.wellington.screenscrapers.Newsitem;
import nz.gen.wellington.screenscrapers.ScreenScraper;

public class WellingtonChildrensHospitalScraperTest extends Base {
	
	protected SimpleDateFormat df;

	protected void setUp() throws Exception {
		df = new SimpleDateFormat();
		df.applyPattern("d MMM yyyy");
	}
	
	public void testScraper() throws Exception {
        final ScreenScraper scraper = new WellingtonChildrensHospitalScraper();        
        final List<Newsitem> extractedItems = scraper.parseContent(loadContent("wch-news.html").toString());
        
        assertEquals(88, extractedItems.size());
        Newsitem first = extractedItems.get(1);
        assertEquals("Woolley Barista Cleans Up for Sick Kids", first.getTitle());
        assertEquals("http://www.justforkids.org.nz/woolley-barista-cleans-up-for-sick-kids/", first.getUrl());
        assertEquals("10 May 2012", df.format(first.getDate().getTime()));
        assertEquals("'Clean-Shaven' isn't a term that is usually associated with Ryan Woolley, a barista at Café Neo on Willis Street.", first.getDescription());
    }
	
}
