package nz.gen.wellington.screenscrapers.wellington;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.Reader;
import java.text.SimpleDateFormat;
import java.util.List;

import junit.framework.TestCase;
import nz.gen.wellington.screenscrapers.Newsitem;
import nz.gen.wellington.screenscrapers.ScreenScraper;

public class WellingtonScoopFeaturesScraperTest extends TestCase {
	
	protected SimpleDateFormat df;

	protected void setUp() throws Exception {
		df = new SimpleDateFormat();
		df.applyPattern("d MMM yyyy");
	}

	protected StringBuffer loadContent(String filename) throws IOException {
		StringBuffer content = new StringBuffer();
		File contentFile = new File(ClassLoader.getSystemClassLoader().getResource(filename).getFile());
		Reader freader = new FileReader(contentFile);
		BufferedReader in = new BufferedReader(freader);
		String str;
		while ((str = in.readLine()) != null) {
			content.append(str);
			content.append("\n");
		}
		in.close();
		freader.close();
		return content;
	}
	
	
	public void testScraper() throws Exception {
        ScreenScraper scraper = new WellingtonScoopFeaturesScraper();
        StringBuffer content = loadContent("wellington-scoop-features.html");
        
        List<Newsitem> extractedItems = scraper.parseContent(content.toString());
        assertEquals(15, extractedItems.size());
        Newsitem first = extractedItems.get(0);
        assertEquals("Wharewaka, wharerugby, whareparty", first.getTitle());
        assertEquals("http://wellington.scoop.co.nz/?p=21818", first.getUrl());
        assertEquals("5 Mar 2010", df.format(first.getDate().getTime()));        
    }
	
}
